package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.basicData.domain.XcrTrademark;
import com.zksy.basicData.service.IXcrTrademarkService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.basicData.utils.DowntemplateUtil;
import com.zksy.common.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.poi.ExcelUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.multipart.MultipartFile;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 商标Controller
 *
 * @author nahida
 * @date 2024-12-12
 */
@RestController
@RequestMapping("/basicData/xcrTrademark")
@Api(tags = "商标", description = "商标desc")
public class XcrTrademarkController extends BaseController{

    @Autowired
    private IXcrTrademarkService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "商标搜索getById")
    @PreAuthorize("@ss.hasPermi('basicData:xcrTrademark:list')")
    public XcrTrademark getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "商标分页")
    @PreAuthorize("@ss.hasPermi('basicData:xcrTrademark:list')")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "商标查询所有")
    @PreAuthorize("@ss.hasPermi('basicData:xcrTrademark:list')")
    public List<XcrTrademark> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增商标
     */
    @PostMapping("/save")
    @ApiOperation(value = "商标新增")
    @Log(title = "新增商标", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody XcrTrademark xcrTrademark) {
        return service.save(xcrTrademark);
    }

    /**
     * 修改商标
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "商标修改")
    @Log(title = "修改商标", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody XcrTrademark xcrTrademark) {
        return service.updateById(xcrTrademark);
    }


    @Log(title = "商标", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除商标", notes = "删除商标")
    @PreAuthorize("@ss.hasPermi('basicData:xcrTrademark:delete')")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    /**
     * 导出商标列表
     */
    @PreAuthorize("@ss.hasPermi('basicData:xcrTrademark:export')")
    @Log(title = "商标", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response,String conditionJson) throws Exception
    {
        List<XcrTrademark> list = service.list(SearchUtil.parseWhereSql(conditionJson));
        ExcelUtil<XcrTrademark> util = new ExcelUtil<XcrTrademark>(XcrTrademark.class);
        util.exportExcel(response, list, "商标数据");
    }
    /**
     * 导入商标列表
     */
    @ApiOperation(value = "商标导入")
    @Log(title = "商标管理", businessType = BusinessType.IMPORT)
    @PreAuthorize("@ss.hasPermi('basicData:xcrTrademark:import')")
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file) throws Exception
    {
        ExcelUtil<XcrTrademark> util = new ExcelUtil<XcrTrademark>(XcrTrademark.class);
        List<XcrTrademark> list = util.importExcel(file.getInputStream());
        return toAjax(service.saveBatch(list));
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException, IOException {
        DowntemplateUtil.downloadTemplate(response,"商标模板");
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除全表", notes = "清除全表")
    @PreAuthorize("@ss.hasPermi('basicData:xcrTrademark:delete')")
    @Log(title = "商标清除全表", businessType = BusinessType.DELETE)
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
}